package com.bomostory.sceneeditmodule

import android.graphics.*
import android.graphics.Paint.ANTI_ALIAS_FLAG

object ImageOperation {
    fun imageoperation(mbitmap: Bitmap, hue: Float, saturation: Float, lum: Float): Bitmap {
        val mbitmap_fu = Bitmap.createBitmap(mbitmap.getWidth(), mbitmap.getHeight(), Bitmap.Config.ARGB_8888)
        val canvas = Canvas(mbitmap_fu)
        val mpaint = Paint(ANTI_ALIAS_FLAG)
        val huematrix = ColorMatrix()
        val saturationmatrix = ColorMatrix()
        val lummatrix = ColorMatrix()
        val imagematrix = ColorMatrix()

        huematrix.setRotate(0, hue)
        huematrix.setRotate(1, hue)
        huematrix.setRotate(2, hue)

        saturationmatrix.setSaturation(saturation)

        lummatrix.setScale(lum, lum, lum, 1f)

        imagematrix.postConcat(huematrix)
        imagematrix.postConcat(saturationmatrix)
        imagematrix.postConcat(lummatrix)
        mpaint.setColorFilter(ColorMatrixColorFilter(imagematrix))
        canvas.drawBitmap(mbitmap, 0f, 0f, mpaint)
        return mbitmap_fu
    }
}

