package com.bomostory.sceneeditmodule.layermanagement

import android.graphics.drawable.Drawable
import android.support.v7.widget.RecyclerView
import android.view.*
import com.bomostory.sceneeditmodule.basicdata.Actor
import com.example.tfat.myapplication.R
import kotlinx.android.synthetic.main.actor_item.view.*
import java.util.*


class LayerAdapter (actorData: ArrayList<Actor>, actorListeners: ArrayList<View.OnTouchListener>) : RecyclerView.Adapter<LayerAdapter.ViewHolder>(), ItemMoveSwipeListener {

    private var data = actorData
    private var listeners = actorListeners
    lateinit var listener: ItemMoveListener
    var layerNum = 0

    override fun getItemCount(): Int {
        return data.size
    }

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        holder.bind(data[position],listeners[position])
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        val v1 = LayoutInflater.from(parent.context).inflate(R.layout.actor_item, parent, false)
        return ViewHolder(v1)
    }

    class ViewHolder (view : View) : RecyclerView.ViewHolder(view) {
        fun bind(actor: Actor, onTouchListener: View.OnTouchListener?) {
            when (actor.isDialogue){
                true -> {
                    itemView.actor_image.setImageResource(actor.resourcePath.toInt())
                }
                false -> itemView.actor_image.setImageDrawable(Drawable.createFromPath(actor.resourcePath))
            }
            itemView.setOnTouchListener(onTouchListener)
        }
    }

    override fun onItemMove(fromPosition: Int, toPosition: Int): Boolean {
        Collections.swap(listeners,fromPosition,toPosition)
        notifyItemMoved(fromPosition, toPosition)
        listener.onItemMove(layerNum, fromPosition, toPosition)
        return true
    }

    override fun onItemSwipe(position: Int) {
    }

    override fun clearView() {
        listener.clearView()
    }

    interface ItemMoveListener{
        fun onItemMove(layerNum: Int, fromPosition: Int, toPosition: Int)
        fun clearView()

    }
}